/*
**  Security Controls V2022.2.1 Connector - Permissions Script
**
**  1. Edit the "SET" line below, replacing the
**     default user (xtraction) with whatever SQL or Windows
**     account Xtraction will use to report against the Xtraction
**     database.  For example, 'xtraction_ro' or '[domain\svc_xtraction]'
**
**  2. Run this script to set the necessary permissions
**
*/

DECLARE @XtractionUsername VARCHAR(100)

--------- CHANGE THE FOLLOWING LINE AS REQUIRED ---------

SET @XtractionUsername = 'xtraction'

-----------------------------------------------------------

exec('GRANT ALTER ON dbo.xtrCumulativePatches TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrCumulativePatches TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrCumulativePatches TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrCumulativePatches TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrCumulativePatches TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrCumulativePatches TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrCurrentPatchCount TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrCurrentPatchStatus TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrDistinctAssessed TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrDistinctAssessed TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrDistinctAssessed TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrDistinctAssessed TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrDistinctAssessed TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrDistinctAssessed TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrDistinctDeployed TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrDistinctPatched TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrDistinctPatched TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrDistinctPatched TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrDistinctPatched TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrDistinctPatched TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrDistinctPatched TO ' + @XtractionUsername)


exec('GRANT ALTER ON dbo.xtrEntityProcessErrorLog TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrEntityProcessErrorLog TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrEntityProcessErrorLog TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrEntityProcessErrorLog TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrEntityProcessErrorLog TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrEntityProcessErrorLog TO ' + @XtractionUsername)


exec('GRANT ALTER ON dbo.xtrEntityProcessLog TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrEntityProcessLog TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrEntityProcessLog TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrEntityProcessLog TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrEntityProcessLog TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrEntityProcessLog TO ' + @XtractionUsername)


exec('GRANT ALTER ON dbo.xtrLinuxCumulativePatches TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrLinuxCumulativePatches TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrLinuxCumulativePatches TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrLinuxCumulativePatches TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrLinuxCumulativePatches TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrLinuxCumulativePatches TO ' + @XtractionUsername)


exec('GRANT ALTER ON dbo.xtrLinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrLinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrLinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrLinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrLinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrLinuxCurrentPatchCount TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrLinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrLinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrLinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrLinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrLinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrLinuxCurrentPatchStatus TO ' + @XtractionUsername)

exec('GRANT ALTER ON dbo.xtrLinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT CONTROL ON dbo.xtrLinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT DELETE ON dbo.xtrLinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT INSERT ON dbo.xtrLinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT SELECT ON dbo.xtrLinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT UPDATE ON dbo.xtrLinuxDistinctDeployed TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_CurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_CurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_CurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_CurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_CurrentPatchCount TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_CurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_CurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_CurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_CurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_CurrentPatchStatus TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_DeleteCPatches TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_DeleteCPatches TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_DeleteCPatches TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_DeleteCPatches TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_DeleteCPatches TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_DeleteObsPatches TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_DeleteObsPatches TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_DeleteObsPatches TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_DeleteObsPatches TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_DeleteObsPatches TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_DeleteODPatches TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_DeleteODPatches TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_DeleteODPatches TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_DeleteODPatches TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_DeleteODPatches TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_DistinctAssessed TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_DistinctAssessed TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_DistinctAssessed TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_DistinctAssessed TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_DistinctAssessed TO ' + @XtractionUsername)


exec('GRANT ALTER ON OBJECT::dbo.xtr_DistinctDeployed TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_DistinctDeployed TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_DistinctDeployed TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_DistinctDeployed TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_DistinctDeployed TO ' + @XtractionUsername)


exec('GRANT ALTER ON OBJECT::dbo.xtr_DistinctPatched TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_DistinctPatched TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_DistinctPatched TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_DistinctPatched TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_DistinctPatched TO ' + @XtractionUsername)




exec('GRANT ALTER ON OBJECT::dbo.xtr_LinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_LinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_LinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_LinuxCurrentPatchCount TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_LinuxCurrentPatchCount TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_LinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_LinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_LinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_LinuxCurrentPatchStatus TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_LinuxCurrentPatchStatus TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_LinuxDeleteCPatches TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_LinuxDeleteCPatches TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_LinuxDeleteCPatches TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_LinuxDeleteCPatches TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_LinuxDeleteCPatches TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_LinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_LinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_LinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_LinuxDistinctDeployed TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_LinuxDistinctDeployed TO ' + @XtractionUsername)


exec('GRANT ALTER ON OBJECT::dbo.xtr_LogErrorInfo TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_LogErrorInfo TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_LogErrorInfo TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_LogErrorInfo TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_LogErrorInfo TO ' + @XtractionUsername)

exec('GRANT ALTER ON OBJECT::dbo.xtr_UpdateData TO ' + @XtractionUsername)
exec('GRANT CONTROL ON OBJECT::dbo.xtr_UpdateData TO ' + @XtractionUsername)
exec('GRANT EXECUTE ON OBJECT::dbo.xtr_UpdateData TO ' + @XtractionUsername)
exec('GRANT TAKE OWNERSHIP ON OBJECT::dbo.xtr_UpdateData TO ' + @XtractionUsername)
exec('GRANT VIEW DEFINITION ON OBJECT::dbo.xtr_UpdateData TO ' + @XtractionUsername)